"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isRowActions = exports.default = exports.SELECTABLE_ID = exports.EXPANDABLE_ID = exports.DRAGGABLE_ID = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactTable = require("react-table");

var _styleConst = require("@cloudflare/style-const");

var _styleContainer = require("@cloudflare/style-container");

var _intlReact = require("@cloudflare/intl-react");

var _elements = require("@cloudflare/elements");

var _componentLink = require("@cloudflare/component-link");

var _componentIcon = require("@cloudflare/component-icon");

var _componentCheckbox = require("@cloudflare/component-checkbox");

var _componentPagination = require("@cloudflare/component-pagination");

var _reactSortableHoc = require("react-sortable-hoc");

var _DragHandle = _interopRequireDefault(require("./DragHandle"));

var _MoveRowButtons = _interopRequireDefault(require("./MoveRowButtons"));

var _reactVirtualized = require("react-virtualized");

var _reactUseMeasure = _interopRequireDefault(require("react-use-measure"));

var _resizeObserver = require("@juggle/resize-observer");

var _CellStyles = require("./CellStyles");

var _HeaderRow = _interopRequireDefault(require("./HeaderRow"));

var _Row = _interopRequireDefault(require("./Row"));

var _excluded = ["rowStyle", "data", "columns", "disableHeaders", "isLoading", "hasError", "isEmpty", "initialSortBy", "initialSelectedRowIds", "renderEmpty", "renderError", "numberOfLoadingRows", "expandable", "onlyOneExpanding", "isRowExpandable", "isRowSelectable", "onSortBy", "onRowClick", "onRowSelect", "className", "pageSize", "GlobalFilter", "globalFilterProps", "filterFunction", "bordered", "onRowMove", "disableRowSelect", "showSelectAllInHeader", "selectedCountKey", "disableSelectAll", "autoResetExpanded", "autoResetPage", "selectAllKey", "clearAllKey", "allSelectedOnPageKey", "allSelectedKey", "wrapperStyle", "getRowId"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ResizeObserver = window.ResizeObserver || _resizeObserver.ResizeObserver;
var SortableList = (0, _reactSortableHoc.SortableContainer)(_reactVirtualized.List);
var SortableRow = (0, _reactSortableHoc.SortableElement)(_Row.default);
var borderColor = _styleConst.variables.colors.gray[7];
var EXPANDABLE_ID = 'expandable-id';
exports.EXPANDABLE_ID = EXPANDABLE_ID;
var SELECTABLE_ID = 'selectable-id';
exports.SELECTABLE_ID = SELECTABLE_ID;
var DRAGGABLE_ID = 'draggable-id';
exports.DRAGGABLE_ID = DRAGGABLE_ID;
var defaultScrollHeight = 700;
var count = 0;
var ScrollWrapper = (0, _styleContainer.applyStaticStyles)("\n  .ReactVirtualized__List {\n    outline: none\n  }\n  .cf-table-row-drag {\n    pointer-events: auto !important;\n    z-index: 2000 !important;\n    box-shadow: 0 0 10px rgba(0, 0, 0, 0.2) !important;\n    background-color: ".concat(_styleConst.variables.colors.background, " !important;\n  }\n  .cf-table-row-drag * {\n    cursor: grabbing !important;\n  }\n  "), _elements.Div);

var isRowActions = function isRowActions(columnId) {
  return [EXPANDABLE_ID, SELECTABLE_ID, DRAGGABLE_ID].includes(columnId);
};

exports.isRowActions = isRowActions;
var draggableColumn = {
  id: DRAGGABLE_ID,
  width: 50,
  Cell: function Cell(_ref) {
    var _row$original, _row$getRowProps, _column$isDragHandleV;

    var row = _ref.row,
        rows = _ref.rows,
        column = _ref.column,
        columns = _ref.columns,
        allColumns = _ref.allColumns;
    var rowId = "table_".concat(column.getTableId(), "_row").concat(((_row$original = row.original) === null || _row$original === void 0 ? void 0 : _row$original.id) || ((_row$getRowProps = row.getRowProps()) === null || _row$getRowProps === void 0 ? void 0 : _row$getRowProps.key));
    var indexOffset = allColumns.length - columns.length;
    return /*#__PURE__*/_react.default.createElement(_CellStyles.DefaultCell, {
      px: 2,
      justifyContent: "center"
    }, ((_column$isDragHandleV = column.isDragHandleVisible) === null || _column$isDragHandleV === void 0 ? void 0 : _column$isDragHandleV.call(column)) && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_DragHandle.default, null), /*#__PURE__*/_react.default.createElement(_MoveRowButtons.default, {
      handleMoveUpClick: row.index > 0 ? function () {
        return column.moveRow(rows, {
          oldIndex: row.index,
          newIndex: row.index - 1
        });
      } : undefined,
      handleMoveDownClick: row.index < rows.length - 1 ? function () {
        column.moveRow(rows, {
          oldIndex: row.index,
          newIndex: row.index + 1
        });
      } : undefined,
      describedBy: columns.map(function (_col, index) {
        return "".concat(rowId, "_cell_").concat(indexOffset + index);
      })
    })));
  }
}; // @ts-ignore

draggableColumn.Cell.displayName = 'DraggableColumnCell';
var expandableColumn = {
  id: EXPANDABLE_ID,
  width: 26,
  Cell: function Cell(_ref2) {
    var row = _ref2.row;
    return /*#__PURE__*/_react.default.createElement(_CellStyles.DefaultCell, {
      px: 1,
      style: _objectSpread(_objectSpread({}, row.isExpanded ? {
        transform: 'rotate(90deg)'
      } : {}), {}, {
        transition: 'transform 0.18s ease-out'
      })
    }, /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, {
      type: "right"
    }));
  }
}; // @ts-ignore

expandableColumn.Cell.displayName = 'ExpandableColumnCell';
var selectableColumn = {
  id: SELECTABLE_ID,
  Header: function Header(_ref3) {
    var _column$getCellData;

    var rows = _ref3.rows,
        column = _ref3.column,
        pageRows = _ref3.pageRows,
        isRowSelectable = _ref3.isRowSelectable,
        selectAllKey = _ref3.selectAllKey;
    // If table is paginated, page contains only the visible rows
    var selectableRows = (pageRows || rows).filter(function (row) {
      return !isRowSelectable || isRowSelectable(row);
    });
    var selectedRows = selectableRows.filter(function (row) {
      return row.isSelected;
    });

    var _useState = (0, _react.useState)(selectedRows.length > 0),
        _useState2 = _slicedToArray(_useState, 2),
        isChecked = _useState2[0],
        setIsChecked = _useState2[1];

    var isIndeterminate = selectedRows.length > 0 && selectedRows.length < selectableRows.length;
    (0, _react.useEffect)(function () {
      setIsChecked(selectedRows.length > 0);
    }, [selectedRows]);

    var handleToggleAll = function handleToggleAll() {
      var selectedValue = !isChecked;
      setIsChecked(selectedValue);
      return selectableRows.forEach(function (row) {
        return row.toggleRowSelected(selectedValue);
      });
    };

    return /*#__PURE__*/_react.default.createElement(_elements.Div, {
      display: "flex",
      alignItems: "flex-start",
      mt: "2px"
    }, /*#__PURE__*/_react.default.createElement(_componentCheckbox.Checkbox, {
      name: "toggleAll",
      onChange: handleToggleAll,
      checked: isChecked,
      indeterminate: isIndeterminate,
      disabled: !selectableRows.length || ((_column$getCellData = column.getCellData) === null || _column$getCellData === void 0 ? void 0 : _column$getCellData.call(column).disableRowSelect),
      value: "true",
      label: ""
    }), !!selectAllKey && /*#__PURE__*/_react.default.createElement(_elements.Span, {
      ml: 3
    }, /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
      id: selectAllKey
    })));
  },
  Cell: function Cell(_ref4) {
    var _column$getCellData2;

    var row = _ref4.row,
        column = _ref4.column,
        isRowSelectable = _ref4.isRowSelectable;
    var isDisabled = isRowSelectable && !isRowSelectable(row) || ((_column$getCellData2 = column.getCellData) === null || _column$getCellData2 === void 0 ? void 0 : _column$getCellData2.call(column).disableRowSelect);
    return /*#__PURE__*/_react.default.createElement(_CellStyles.DefaultCell, {
      alignItems: "flex-start",
      pr: 0,
      pt: 2
    }, /*#__PURE__*/_react.default.createElement(_componentCheckbox.Checkbox, _extends({
      name: "toggleRow",
      onClick: function onClick(e) {
        return e.stopPropagation();
      }
    }, row.getToggleRowSelectedProps(), isDisabled ? {
      checked: false
    } : {}, {
      // Force checked = false if disabled
      disabled: isDisabled,
      value: "true",
      label: ""
    })));
  }
}; // @ts-ignore

selectableColumn.Header.displayName = 'SelectableColumnHeader'; // @ts-ignore

selectableColumn.Cell.displayName = 'SelectableColumnCell';
var defaultColumn = {
  width: 50,
  Cell: function Cell(_ref5) {
    var value = _ref5.cell.value;
    return /*#__PURE__*/_react.default.createElement(_CellStyles.DefaultCell, null, value);
  }
}; // @ts-ignore

defaultColumn.Cell.displayName = 'DefaultStyleColumnCell';

var defaultComponent = function defaultComponent() {
  return /*#__PURE__*/_react.default.createElement(_react.Fragment, null);
};

var defaultNoop = function defaultNoop() {};

var defaultWrapperStyle = {
  position: 'relative',
  borderBottom: "1px solid ".concat(borderColor)
};

var Table = function Table(_ref6) {
  var rowStyle = _ref6.rowStyle,
      data = _ref6.data,
      columns = _ref6.columns,
      disableHeaders = _ref6.disableHeaders,
      isLoading = _ref6.isLoading,
      hasError = _ref6.hasError,
      isEmpty = _ref6.isEmpty,
      _ref6$initialSortBy = _ref6.initialSortBy,
      initialSortBy = _ref6$initialSortBy === void 0 ? [] : _ref6$initialSortBy,
      _ref6$initialSelected = _ref6.initialSelectedRowIds,
      initialSelectedRowIds = _ref6$initialSelected === void 0 ? {} : _ref6$initialSelected,
      _ref6$renderEmpty = _ref6.renderEmpty,
      Empty = _ref6$renderEmpty === void 0 ? defaultComponent : _ref6$renderEmpty,
      _ref6$renderError = _ref6.renderError,
      Error = _ref6$renderError === void 0 ? defaultComponent : _ref6$renderError,
      _ref6$numberOfLoading = _ref6.numberOfLoadingRows,
      numberOfLoadingRows = _ref6$numberOfLoading === void 0 ? 10 : _ref6$numberOfLoading,
      expandable = _ref6.expandable,
      onlyOneExpanding = _ref6.onlyOneExpanding,
      isRowExpandable = _ref6.isRowExpandable,
      isRowSelectable = _ref6.isRowSelectable,
      _ref6$onSortBy = _ref6.onSortBy,
      onSortBy = _ref6$onSortBy === void 0 ? defaultNoop : _ref6$onSortBy,
      _ref6$onRowClick = _ref6.onRowClick,
      onRowClick = _ref6$onRowClick === void 0 ? defaultNoop : _ref6$onRowClick,
      onRowSelect = _ref6.onRowSelect,
      className = _ref6.className,
      pageSize = _ref6.pageSize,
      GlobalFilter = _ref6.GlobalFilter,
      globalFilterProps = _ref6.globalFilterProps,
      filterFunction = _ref6.filterFunction,
      bordered = _ref6.bordered,
      onRowMove = _ref6.onRowMove,
      disableRowSelect = _ref6.disableRowSelect,
      showSelectAllInHeader = _ref6.showSelectAllInHeader,
      selectedCountKey = _ref6.selectedCountKey,
      _ref6$disableSelectAl = _ref6.disableSelectAll,
      disableSelectAll = _ref6$disableSelectAl === void 0 ? false : _ref6$disableSelectAl,
      autoResetExpanded = _ref6.autoResetExpanded,
      autoResetPage = _ref6.autoResetPage,
      _ref6$selectAllKey = _ref6.selectAllKey,
      selectAllKey = _ref6$selectAllKey === void 0 ? 'common.table.select_all' : _ref6$selectAllKey,
      _ref6$clearAllKey = _ref6.clearAllKey,
      clearAllKey = _ref6$clearAllKey === void 0 ? 'common.table.clear_all' : _ref6$clearAllKey,
      _ref6$allSelectedOnPa = _ref6.allSelectedOnPageKey,
      allSelectedOnPageKey = _ref6$allSelectedOnPa === void 0 ? 'common.table.all_selected_on_page' : _ref6$allSelectedOnPa,
      _ref6$allSelectedKey = _ref6.allSelectedKey,
      allSelectedKey = _ref6$allSelectedKey === void 0 ? 'common.table.all_selected' : _ref6$allSelectedKey,
      _ref6$wrapperStyle = _ref6.wrapperStyle,
      wrapperStyle = _ref6$wrapperStyle === void 0 ? defaultWrapperStyle : _ref6$wrapperStyle,
      getRowId = _ref6.getRowId,
      wrapperProps = _objectWithoutProperties(_ref6, _excluded);

  var listRef = (0, _react.useRef)();
  var canMoveRows = !!(onRowMove && data && (data === null || data === void 0 ? void 0 : data.length) > 0);

  var _useState3 = (0, _react.useState)(function () {
    return ++count;
  }),
      _useState4 = _slicedToArray(_useState3, 1),
      tableId = _useState4[0];

  var dragState = (0, _react.useMemo)(function () {
    return {
      canDrag: true
    };
  }, []);

  var _useState5 = (0, _react.useState)({
    disableRowSelect: disableRowSelect
  }),
      _useState6 = _slicedToArray(_useState5, 1),
      cellData = _useState6[0];

  cellData.disableRowSelect = disableRowSelect;
  var memoizedData = (0, _react.useMemo)(function () {
    return isLoading ? Array.from({
      length: numberOfLoadingRows
    }, function () {
      return {};
    }) : _toConsumableArray(data !== null && data !== void 0 ? data : []);
  }, [data, isLoading, numberOfLoadingRows]);

  var _useState7 = (0, _react.useState)(memoizedData),
      _useState8 = _slicedToArray(_useState7, 2),
      reorderableData = _useState8[0],
      setReorderableData = _useState8[1];

  (0, _react.useEffect)(function () {
    return setReorderableData(memoizedData);
  }, [memoizedData]);
  var memoizedColumns = (0, _react.useMemo)(function () {
    return columns.map(function (column) {
      return _objectSpread(_objectSpread({}, column), {}, {
        disableSortBy: !column.enableSortBy
      });
    });
  }, [columns]);

  if ([GlobalFilter, filterFunction].filter(function (item) {
    return item;
  }).length === 1) {
    console.error('Both GlobalFilter and filterFunction must be specified together');
  }

  var cellMeasurerCache = (0, _react.useMemo)(function () {
    return new _reactVirtualized.CellMeasurerCache({
      // TODO prop
      minHeight: 37,
      fixedWidth: true
    });
  }, []); // Use the cellMeasurer cache to determine the size of table when using
  // virtual scrolling.

  var scrollHeight = 0;

  if (onRowMove && pageSize) {
    for (var ii = 0; ii < pageSize; ++ii) {
      var _cellMeasurerCache$_r;

      // @ts-ignore
      scrollHeight += ((_cellMeasurerCache$_r = cellMeasurerCache._rowHeightCache) === null || _cellMeasurerCache$_r === void 0 ? void 0 : _cellMeasurerCache$_r["".concat(ii, "-0")]) || 0;
    }
  }

  scrollHeight = scrollHeight || defaultScrollHeight;

  var _useTable = _reactTable.useTable.apply(void 0, [{
    data: canMoveRows ? reorderableData : memoizedData,
    columns: memoizedColumns,
    defaultColumn: defaultColumn,
    manualSortBy: true,
    disableMultiSort: true,
    autoResetExpanded: !!autoResetExpanded,
    autoResetPage: !!autoResetPage,
    initialState: {
      sortBy: initialSortBy,
      selectedRowIds: initialSelectedRowIds,
      pageSize: pageSize
    },
    globalFilter: filterFunction,
    // @ts-ignore
    getRowId: getRowId
  }, _reactTable.useFlexLayout].concat(_toConsumableArray(GlobalFilter ? [_reactTable.useGlobalFilter] : []), [_reactTable.useSortBy, _reactTable.useExpanded, _reactTable.useRowSelect], _toConsumableArray(pageSize ? [_reactTable.usePagination] : []), [function (hooks) {
    if (onRowSelect) {
      hooks.visibleColumns.push(function (columns) {
        return [_objectSpread(_objectSpread({}, selectableColumn), {}, {
          width: showSelectAllInHeader ? 120 : 34,
          isRowSelectable: isRowSelectable,
          getCellData: function getCellData() {
            return cellData;
          }
        })].concat(_toConsumableArray(columns));
      });
    }

    if (canMoveRows) {
      hooks.visibleColumns.push(function (columns) {
        return [_objectSpread(_objectSpread({}, draggableColumn), {}, {
          isDragHandleVisible: function isDragHandleVisible() {
            return dragState.canDrag;
          },
          getTableId: function getTableId() {
            return tableId;
          },
          moveRow: function moveRow(rowsToUpdate, _ref7) {
            var newIndex = _ref7.newIndex,
                oldIndex = _ref7.oldIndex;
            var updatedData = (0, _reactSortableHoc.arrayMove)(rowsToUpdate.map(function (row) {
              return row.original;
            }), oldIndex, newIndex);
            setReorderableData(updatedData);
            onRowMove === null || onRowMove === void 0 ? void 0 : onRowMove(updatedData, {
              newIndex: newIndex,
              oldIndex: oldIndex
            });
          }
        })].concat(_toConsumableArray(columns));
      });
    }

    if (expandable) {
      hooks.visibleColumns.push(function (columns) {
        return [expandableColumn].concat(_toConsumableArray(columns));
      });
    }
  }])),
      getTableProps = _useTable.getTableProps,
      getTableBodyProps = _useTable.getTableBodyProps,
      gotoPage = _useTable.gotoPage,
      headerGroups = _useTable.headerGroups,
      rows = _useTable.rows,
      page = _useTable.page,
      prepareRow = _useTable.prepareRow,
      _useTable$state = _useTable.state,
      sortBy = _useTable$state.sortBy,
      selectedRowIds = _useTable$state.selectedRowIds,
      pageIndex = _useTable$state.pageIndex,
      globalFilter = _useTable$state.globalFilter,
      canPreviousPage = _useTable.canPreviousPage,
      canNextPage = _useTable.canNextPage,
      previousPage = _useTable.previousPage,
      nextPage = _useTable.nextPage,
      preGlobalFilteredRows = _useTable.preGlobalFilteredRows,
      _setGlobalFilter = _useTable.setGlobalFilter,
      toggleAllRowsSelected = _useTable.toggleAllRowsSelected,
      toggleAllRowsExpanded = _useTable.toggleAllRowsExpanded;

  (0, _react.useEffect)(function () {
    if (!onRowSelect || isLoading) return;
    var rowObjects = Object.keys(selectedRowIds).reduce(function (acc, rId) {
      var rawRow = (preGlobalFilteredRows || rows).find(function (_ref8) {
        var id = _ref8.id;
        return rId === id;
      });
      if (!rawRow) return acc;
      if (isRowSelectable && !isRowSelectable(rawRow)) return acc;
      return [].concat(_toConsumableArray(acc), [_objectSpread({
        rowIndex: rawRow.index
      }, rawRow.original)]);
    }, []);
    onRowSelect(rowObjects);
  }, [selectedRowIds, isLoading]);
  (0, _react.useEffect)(function () {
    onSortBy(sortBy);
  }, [sortBy]);
  (0, _react.useEffect)(function () {
    cellMeasurerCache === null || cellMeasurerCache === void 0 ? void 0 : cellMeasurerCache.clearAll();
  }, [columns, data]);

  var _useMeasure = (0, _reactUseMeasure.default)({
    polyfill: ResizeObserver
  }),
      _useMeasure2 = _slicedToArray(_useMeasure, 2),
      ref = _useMeasure2[0],
      containerWidth = _useMeasure2[1].width;

  var selectedRowsCount = Object.keys(selectedRowIds).length;
  var allSelected = selectedRowsCount === rows.length;
  var pageSelected = !!pageSize && page.every(function (row) {
    return row.isSelected;
  });
  var filtered = !!preGlobalFilteredRows && preGlobalFilteredRows.length !== rows.length;
  var showSelectAll = !!selectedRowsCount && pageSelected;
  return /*#__PURE__*/_react.default.createElement(_elements.Div, wrapperProps, !!GlobalFilter && /*#__PURE__*/_react.default.createElement(GlobalFilter, _extends({
    rows: rows,
    preGlobalFilteredRows: preGlobalFilteredRows,
    globalFilter: globalFilter,
    selectedRowsCount: selectedRowsCount,
    toggleAllRowsSelected: toggleAllRowsSelected,
    setGlobalFilter: function setGlobalFilter(filter) {
      dragState.canDrag = !filter;

      if (!!pageSize) {
        gotoPage(0);
      }

      _setGlobalFilter(filter);
    }
  }, globalFilterProps || {})), /*#__PURE__*/_react.default.createElement("div", {
    ref: ref,
    className: className,
    style: _objectSpread(_objectSpread({}, bordered ? {
      border: "1px solid ".concat(borderColor)
    } : {}), wrapperStyle)
  }, /*#__PURE__*/_react.default.createElement(_elements.Div, getTableProps(), /*#__PURE__*/_react.default.createElement(_HeaderRow.default, {
    disableHeaders: disableHeaders,
    headerGroups: headerGroups,
    isLoading: isLoading,
    isEmpty: isEmpty,
    hasError: hasError,
    selectAllKey: showSelectAllInHeader ? selectAllKey : undefined
  }), (showSelectAll || selectedCountKey) && !disableRowSelect && !disableSelectAll && /*#__PURE__*/_react.default.createElement(_elements.Div, {
    backgroundColor: "gray.9",
    textAlign: "center",
    padding: 2,
    borderRadius: 2,
    borderBottom: "1px solid",
    borderColor: borderColor
  }, /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
    id: selectedCountKey || (allSelected ? allSelectedKey : allSelectedOnPageKey),
    smartCount: !selectedCountKey && pageSize && !allSelected ? page.filter(function (row) {
      return row.isSelected;
    }).length : selectedRowsCount
  }), /*#__PURE__*/_react.default.createElement(_componentLink.Link, {
    pl: 3,
    onClick: function onClick(e) {
      e.preventDefault();
      toggleAllRowsSelected(!allSelected);
    }
  }, /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
    id: allSelected ? clearAllKey : selectAllKey
  }))), /*#__PURE__*/_react.default.createElement(_elements.Div, getTableBodyProps(), (!isLoading && isEmpty || filtered && !rows.length) && /*#__PURE__*/_react.default.createElement(Empty, {
    globalFilter: globalFilter
  }), !isLoading && hasError && /*#__PURE__*/_react.default.createElement(Error, null), (!isEmpty || !hasError) && (!filtered && canMoveRows ? /*#__PURE__*/_react.default.createElement(ScrollWrapper, {
    style: {
      height: scrollHeight + 'px'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactVirtualized.AutoSizer, null, function (_ref9) {
    var width = _ref9.width;
    return /*#__PURE__*/_react.default.createElement(SortableList, {
      ref: listRef,
      deferredMeasurementCache: cellMeasurerCache,
      rowHeight: cellMeasurerCache.rowHeight,
      height: scrollHeight,
      rowCount: rows.length,
      width: width,
      rowRenderer: function rowRenderer(_ref10) {
        var _row$getRowProps2;

        var index = _ref10.index,
            style = _ref10.style,
            parent = _ref10.parent;
        var row = rows[index];
        prepareRow(row); // Use row.original.id as key instead of row.getRowProps()?.key to fix the bug causing by index shiftting
        // ex: row.original.id => 911874bcebe89ca25c0d9e415de7f634, row.getRowProps()?.key => row_0

        var rowId = "table_".concat(tableId, "_row").concat(row.original.id || ((_row$getRowProps2 = row.getRowProps()) === null || _row$getRowProps2 === void 0 ? void 0 : _row$getRowProps2.key));
        return /*#__PURE__*/_react.default.createElement(_reactVirtualized.CellMeasurer, {
          cache: cellMeasurerCache,
          columnIndex: 0,
          key: "sortable-row-".concat(rowId),
          parent: parent,
          rowIndex: index
        }, /*#__PURE__*/_react.default.createElement(SortableRow, {
          row: row,
          rowId: rowId,
          index: index,
          rowIndex: index,
          style: style,
          rowStyle: _objectSpread(_objectSpread({}, rowStyle), style),
          isLoading: isLoading,
          striped: false,
          rowHighlight: false,
          onRowClick: onRowClick,
          containerWidth: containerWidth,
          disabled: isRowSelectable && !isRowSelectable(row) || disableRowSelect
        }));
      },
      lockAxis: "y",
      helperClass: "cf-table-row-drag",
      useDragHandle: true,
      onSortEnd: function onSortEnd(_ref11) {
        var newIndex = _ref11.newIndex,
            oldIndex = _ref11.oldIndex;
        cellMeasurerCache.clearAll();
        var updatedData = (0, _reactSortableHoc.arrayMove)(reorderableData, oldIndex, newIndex);
        setReorderableData(updatedData);
        onRowMove === null || onRowMove === void 0 ? void 0 : onRowMove(updatedData, {
          newIndex: newIndex,
          oldIndex: oldIndex
        });
      }
    });
  })) : (page || rows).map(function (row, i) {
    var _row$getRowProps3;

    prepareRow(row); // Use row.original.id as key instead of row.getRowProps()?.key to fix the bug causing by index shiftting
    // ex: row.original.id => 911874bcebe89ca25c0d9e415de7f634, row.getRowProps()?.key => row_0

    var rowId = "table_".concat(tableId, "_row").concat(row.original.id || ((_row$getRowProps3 = row.getRowProps()) === null || _row$getRowProps3 === void 0 ? void 0 : _row$getRowProps3.key));
    return /*#__PURE__*/_react.default.createElement(_Row.default, {
      key: rowId,
      testId: "row_".concat(row.original.id),
      row: row,
      rowIndex: i,
      rowId: rowId,
      rowStyle: rowStyle,
      expandable: expandable,
      isRowExpandable: isRowExpandable,
      isRowSelectable: isRowSelectable,
      onlyOneExpanding: onlyOneExpanding,
      toggleAllRowsExpanded: toggleAllRowsExpanded,
      isLoading: isLoading,
      striped: false,
      rowHighlight: false,
      onRowClick: onRowClick,
      containerWidth: containerWidth,
      disabled: isRowSelectable && !isRowSelectable(row)
    });
  })))), !onRowMove && !!pageSize && rows.length > pageSize && /*#__PURE__*/_react.default.createElement(_elements.Div, {
    borderTop: bordered ? 'none' : '1px solid',
    borderColor: borderColor
  }, /*#__PURE__*/_react.default.createElement(_componentPagination.Pagination, {
    p: 2,
    loading: isLoading,
    start: pageIndex * pageSize + 1,
    end: Math.min(pageIndex * pageSize + pageSize, rows.length),
    total: rows.length,
    onPrevClick: previousPage,
    onNextClick: nextPage,
    disablePreviousButton: !canPreviousPage,
    disableNextButton: !canNextPage
  }))));
};

var _default = Table;
exports.default = _default;